/*#######################################################################################
AVR DCF77 Clock 

Copyright (C) 2005 Ulrich Radig

#######################################################################################*/

#include <stdio.h>
#include <avr/io.h>
#include <avr/interrupt.h>

#include "clock.h"

#define DEBUG

//############################################################################
//Hauptprogramm
int main (void) {
  uint8_t ziffern[10] = {119, 68, 107, 110, 92, 62, 63, 100, 127, 126};
  int secondchanged = 0;

  DDRB |= (1 << PB0) | (1 << PB1) | (1 << PB2) | (1 << PB3) | (1 << PB4) | (1 << PB5) | (1 << PB6);
  
  DDRC |= (1 << PC2) | (1 << PC3) | (1 << PC4) | (1 << PC5);

  DDRD |= (1 << PD7);

  __asm__("sei");

	//Starten der DCF77 Uhr
	Start_Clock();

	while (1)	{
#ifdef DEBUG
    if (flags.dcf_rx) {
      PORTD |= (1 << PD7);
    } else {
      PORTD &= ~(1 << PD7);
    }
#endif

    switch(secondchanged) {
      case 0:     PORTC = 0;
                  PORTC |= (1 << PC2);
                  PORTB = ziffern[hh / 10];
                  break;
      case 1:     PORTC = 0;
                  PORTC |= (1 << PC3);
                  PORTB = ziffern[hh % 10];
                  break;
      case 2:     PORTC = 0;
                  PORTC |= (1 << PC4);
                  PORTB = ziffern[mm / 10];
                  break;
      case 3:     PORTC = 0;
                  PORTC |= (1 << PC5);
                  PORTB = ziffern[mm % 10];
                  break;
    }
    secondchanged++;
    if (secondchanged > 3)
      secondchanged = 0;

		}
    return (1);
}
